* PACKAGE     !" 2 $B<!85%V%7%M%9%/%b%G%k(B $BN.@~4X?t$+$iB.EY>l$r5a$a$k(B
*"                                             97/02/13 S.Takehiro
******************************************************************
      PROGRAM PSI2UW
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HEADP ( NDC )*(NCC)
      CHARACTER  HEADU ( NDC )*(NCC)
      CHARACTER  HEADW ( NDC )*(NCC)
      REAL       GDPSI  ( IJKDIM )
      REAL       GDU    ( IJKDIM )
      REAL       GDW    ( IJKDIM )
*
      DATA       IFILE / 50 /
*
      CHARACTER  HFILE(1)  *(NFILN)
      DATA       HFILE / 'gtool.out' /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
*
*" [$B%*%W%7%g%s(B]
*
      NAMELIST  /OPTION/ HFILE, OUT, HELP
*
*" < 1. $B%3%^%s%I%i%$%s2r@O(B >
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HEADP , IJKDIM )
      CALL GTSIZE ( HEADZ , IJKDIM )
      CALL GTSIZE ( HEADT , IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE, OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE, HFILE )
      CALL GFWOPN ( JFILE, OUT )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
*"  < 1. $B%G!<%?FI$_9~$_(B, $B2C9)(B >
*
      II = 0
 1100 CONTINUE
*
         CALL GFREAD 
     O            ( HEADP , GDPSI , IEOD  ,
     I              IFILE , 1               )
*
         IF ( IEOD .EQ. 0 ) THEN
            CALL CALUW
     I            ( HEADP, GDPSI , 
     O              HEADU, GDU   ,
     O              HEADW, GDW     )
*
            CALL  GFWRIT
     I           ( HEADU, GDU ,
     I             JFILE , 1     , 0  )
            CALL  GFWRIT
     I           ( HEADW, GDW ,
     I             JFILE , 1     , 0  )
*
      GOTO 1100
         ENDIF
*
      CALL GFCLSE ( IFILE )
*
      CALL GGCLSE
*
      STOP
      END
**********************************************************************
      SUBROUTINE CALUW
     I            ( HEADP, GDPSI , 
     O              HEADU, GDU   ,
     O              HEADW, GDW     )
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
      INCLUDE    (GZIWRK)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#include         "gziwrk.F"
#endif
*
      CHARACTER  HEADP ( NDC )*(NCC)
      CHARACTER  HEADU ( NDC )*(NCC)
      CHARACTER  HEADW ( NDC )*(NCC)
      REAL       GDPSI  ( IJKDIM )
      REAL       GDU    ( IJKDIM )
      REAL       GDW    ( IJKDIM )
*
      CHARACTER  HEADX( NDC )*(NCC)
      REAL       AXISX ( NW )
      INTEGER    IXDIM
      CHARACTER  HEADZ( NDC )*(NCC)
      REAL       AXISZ ( NW )
      INTEGER    IZDIM
*
      CHARACTER  HAXD *(NCC)
      LOGICAL    OSUBCK
      INTEGER    IJK( NW, NW )
*
*"         < 1. $B<4%U%!%$%k$NFI$_9~$_(B >
*
      CALL GTPGET ( 'SUBCHK', OSUBCK )
      CALL GTSIZE ( HEADX  ,  NW     )
      CALL GTSIZE ( HEADZ  ,  NW     )
*
      CALL GUQAXL
     I            ( HEADP , 1     , 'LOC' ,
     O              HEADX, AXISX , ACYCLX , IXMAX ,IEOD   )
      CALL GHCGET ( HEADX, 'DSET' , HAXD   )
      IF ( HAXD(1:1) .EQ. 'C' ) THEN
         IXDIM = IXMAX+1
      ELSE
         IXDIM = IXMAX
      ENDIF
*
      CALL GUQAXL
     I            ( HEADP , 3     , 'LOC' ,
     O              HEADZ , AXISZ , ACYCLZ, IZMAX ,IEOD   )
      CALL GHCGET ( HEADZ, 'DSET' , HAXD   )
      IF ( HAXD(1:1) .EQ. 'C' ) THEN
         IZDIM = IZMAX+1
      ELSE
         IZDIM = IZMAX
      ENDIF
*
c$$$      CALL GTPSET ( 'SUBCHK', OSUBCK )
*
      DO 1100 IZ = 1, IZDIM
         DO 1100 IX = 1, IXDIM
            IJK(IX,IZ) = IX + IXDIM*(IZ-1)
 1100 CONTINUE 
*
*"         < 2. $BN.B.>l$N7W;;(B >
*
      DO 2100 IZ = 2, IZDIM-1
         DO 2100 IX = 1, IXDIM
            GDU( IJK(IX,IZ) ) 
     &       =( GDPSI(IJK(IX,IZ+1)) - GDPSI(IJK(IX,IZ-1)) )
     &         / ( AXISZ(IZ+1)-AXISZ(IZ-1) )
 2100 CONTINUE 
*
      DO 2200 IX = 1, IXDIM
            GDU( IJK(IX,IZDIM) ) 
     &       =( GDPSI(IJK(IX,IZDIM)) - GDPSI(IJK(IX,IZDIM-1)) )
     &         / ( AXISZ(IZDIM)-AXISZ(IZDIM-1) )
            GDU( IJK(IX,1) ) 
     &       =( GDPSI(IJK(IX,2)) - GDPSI(IJK(IX,1)) )
     &         / ( AXISZ(2)-AXISZ(1) )
 2200 CONTINUE 
*
      DO 2300 IZ = 1, IZDIM
         DO 2300 IX = 2, IXDIM-1
            GDW( IJK(IX,IZ) ) 
     &       = - ( GDPSI(IJK(IX+1,IZ)) - GDPSI(IJK(IX-1,IZ)) )
     &           / ( AXISX(IX+1)-AXISX(IX-1) )
 2300 CONTINUE 
*
      DO 2400 IZ = 1, IZDIM
            GDW( IJK(1,IZ) ) 
     &       = - ( GDPSI(IJK(2,IZ)) - GDPSI(IJK(IXDIM-1,IZ)) )
     &           / ( AXISX(2)-AXISX(IXDIM-1) )
            GDW( IJK(IXDIM,IZ) ) =  GDW( IJK(1,IZ) ) 
 2400 CONTINUE 
*
*"         < 3. $B%X%C%@!<$N:n@.(B >
*
      CALL GHCOPY 
     I     (  HEADP, 
     O        HEADU  )
*
      CALL GHCSET( HEADU , 'ITEM', 'U' )
      CALL GHCSTS( HEADU , 'TITL', 'U-velocity' )
*   
      CALL GHCOPY 
     I     (  HEADP, 
     O        HEADW  )
*
      CALL GHCSET( HEADW , 'ITEM', 'W' )
      CALL GHCSTS( HEADW , 'TITL', 'W-velocity' )
*
      RETURN
      END
